------------------------------------------------------------------------------------------------------
-- Necrosis LdC
--
-- Crateur initial (US) : Infernal (http://www.revolvus.com/games/interface/necrosis/)
-- Implmentation de base (FR) : Tilienna Thorondor
-- Reprise du projet : Lomig & Nyx des Larmes de Cenarius, Kael'Thas
-- 
-- Skins et voix Franaises : Eliah, Ner'zhul
-- Version Allemande par Arne Meier
-- Remerciements spciaux pour Sadyre (JoL)
-- Version 7.02.2006-1
------------------------------------------------------------------------------------------------------



------------------------------------------------
-- VERSION FRANCAISE DES FONCTIONS --
------------------------------------------------

if ( GetLocale() == "frFR" ) then

NECROSIS_UNIT_WARLOCK = "D\195\169moniste";

NECROSIS_ANTI_FEAR_SPELL = {
	-- Buffs giving temporary immunity to fear effects
	["Buff"] = {
		"Gardien de peur",				-- Dwarf priest racial trait
		"Volont\195\169 des r\195\169prouv\195\169",	-- Forsaken racial trait
		"Sans peur",					-- Trinket
		"Furie Berzerker",				-- Warrior Fury talent
		"T\195\169m\195\169rit\195\169",		-- Warrior Fury talent
		"Souhait mortel",				-- Warrior Fury talent
		"Courroux bestial",				-- Hunter Beast Mastery talent (pet only)
		"Carapace de glace",				-- Mage Ice talent
		"Protection divine",				-- Paladin Holy buff
		"Bouclier divin",				-- Paladin Holy buff
		"Totem de s\195\169isme",			-- Shaman totem
		"Abolir la magie"				-- Majordomo (NPC) spell
		--  "Grounding Totem" is not considerated, as it can remove other spell than fear, and only one each 10 sec.		
	},

	-- Debuffs and curses giving temporary immunity to fear effects
	["Debuff"] = {
		"Mal\195\169diction de t\195\169m\195\169rit\195\169"		-- Warlock curse
	}
};

-- Creature type absolutly immune to fear effects
NECROSIS_ANTI_FEAR_UNIT = {
	"Mort-vivant"
};

-- Word to search for spell immunity. First (.+) replace the spell's name, 2nd (.+) replace the creature's name
NECROSIS_ANTI_FEAR_SRCH = "Votre (.+) rate. (.+) y est insensible."

NecrosisDemon = {
	["Diablotin"] = {
		["Spell"] = {"Changement de phase","Firebolt","Bouclier de feu","Pacte de sang"},
		["Time"] = {0,0,0,0},
		["Cooldown"] = {10,2,0,0},
	},
	["Marcheur du Vide"] = {
		Spell = {"Consumer les ombres","Tourment","Souffrance","Sacrifice"},
		Time = {0,0,0,0},
		Cooldown = {10,5,120,0}
	},
	["Succube"] = {
		Spell = {"Fouet de la douleur","S\195\169duction","Baiser apaisant","Invisibilit\195\169 mineure"},
		Time = {0,0,0,0},
		Cooldown = {12,0,4,0}
	},
	["Chasseur corrompu"] = {
		Spell = {"Corruption sanguine","Verrou magique","Paranoia","Festin magique"},
		Time = {0,0,0,0},
		Cooldown = {0,30,0,8}
	},
	["Garde funeste"] = {
		Spell = {"Thunderstomp","Pluie de feu","Cripple"},
		Time = {0,0,0},
		Cooldown = {5,5,20}
	},
};

NECROSIS_SPELL_TABLE = {
	["ID"] = {},
	["Rank"] = {},
	["Name"] = {
		"Invocation d'un palefroi corrompu",			--1
		"Invocation d'un Destrier de l'Effroi",			--2
		"Invocation d'un diablotin",				--3
		"Invocation d'un marcheur du Vide",			--4
		"Invocation d'une succube",				--5
		"Invocation d'un chasseur corrompu",			--6
		"Trait de l'ombre",					--7	
		"Inferno",						--8
		"Bannir",						--9
		"Asservir d\195\169mon",				--10
		"R\195\169surrection de Pierre d'\195\162me",		--11
		"Immolation",						--12	
		"Peur",							--13
		"Corruption",						--14
		"Domination corrompue",					--15
		"Mal\195\169diction funeste",				--16
		"Sacrifice",						--17
		"Feu de l'\195\162me",					--18
		"Voile mortel",						--19
		"Br\195\187lure de l'ombre",				--20
		"Conflagration",					--21
		"Mal\195\169diction d'agonie",				--22
		"Mal\195\169diction de faiblesse",			--23
		"Mal\195\169diction de t\195\169m\195\169rit\195\169",	--24
		"Mal\195\169diction des langages",			--25
		"Mal\195\169diction des \195\169l\195\169ments",	--26
		"Mal\195\169diction des t\195\169n\195\168bres",	--27
		"Siphon de vie",					--28
		"Hurlement de terreur",					--29
		"Rituel de mal\195\169diction",				--30
		"Armure d\195\169moniaque",				--31
		"Respiration interminable",				--32
		"Invisibilit\195\169",					--33
		"Oeil de Kilrogg",					--34
		"Asservir d\195\169mon",				--35
		"Peau de d\195\169mon",					--36
		"Rituel d'invocation",					--37
		"Lien spirituel",					--38
		"D\195\169tection des d\195\169mons",			--39
	},
	["CastTime"] = {},
	["Mana"] = {},
	["Length"] = {
		0,							--1
		0,							--2
		0,							--3
		0,							--4
		0,							--5
		0,							--6
		0,							--7
		3600,							--8
		30,							--9
		30000,							--10
		1800,							--11
		15,							--12
		15,							--13
		17,							--14
		900,							--15
		60,							--16
		30,							--17
		60,							--18
		120,							--19
		15,							--20
		10,							--21
		24,							--22
		120,							--23
		120,							--24
		30,							--25
		300,							--26
		300,							--27
		30,							--28
		40,							--29
		0,							--30
		0,							--31
		0,							--32
		0,							--33
		0,							--34
		0,							--35
		0,							--36
		0,							--37
		0,							--38
		0,							--39
	},
	["Type"] = {
		0,							--1
		0,							--2
		0,							--3
		0,							--4
		0,							--5
		0,							--6
		0,							--7
		3,							--8
		2,							--9
		2,							--10
		1,							--11
		5,							--12
		5,							--13
		5,							--14
		3,							--15
		3,							--16
		3,							--17
		3,							--18
		3,							--19
		3,							--20
		3,							--21	
		4,							--22
		4,							--23
		4,							--24
		4,							--25
		4,							--26
		4,							--27
		5,							--28
		3,							--29
		0,							--30
		0,							--31
		0,							--32
		0,							--33
		0,							--34
		0,							--35
		0,							--36
		0,							--37
		0,							--38
		0,							--39
	}
};
-- Type 0 = Pas de Timer
-- Type 1 = Timer permanent principal
-- Type 2 = Timer permanent
-- Type 3 = Timer de cooldown
-- Type 4 = Timer de maldiction
-- Type 5 = Timer de combat

NECROSIS_ITEM = {
	["Soulshard"] = "Fragment d'\195\162me",
	["Soulstone"] = "Pierre d'\195\162me",
	["Healthstone"] = "Pierre de soins",
	["Spellstone"] = "Pierre de sort",
	["Firestone"] = "Pierre de feu",
	["Offhand"] = "Tenu en main gauche",
	["Twohand"] = "Deux mains",
	["InfernalStone"] = "Pierre infernale",
	["DemoniacStone"] = "Figurine d\195\169moniaque",
	["Hearthstone"] = "Pierre de foyer",
	["SoulPouch"] = {"Bourse d'\195\162me", "Sac en gangrtoffe", "Sac en coeur de gangrtoffe"}
};


NECROSIS_STONE_RANK = {
	[1] = "mineure",			-- Rank Minor
	[2] = "inf\195\169rieure",		-- Rank Lesser
	[3] = " ",				-- Rank Intermediate, no name
	[4] = "sup\195\169rieure",		-- Rank Greater
	[5] = "majeure"				-- Rank Major
};

NECROSIS_NIGHTFALL = {
	["BoltName"] = "Trait",
	["ShadowTrance"] = "Transe de l'ombre",
};

NECROSIS_CREATE = {
	["Soulstone"] = "ation de Pierre d'\195\162me",
	["Healthstone"] = "ation de Pierre de soins",
	["Spellstone"] = "ation de Pierre de sort",
	["Firestone"] = "Pierre de feu"
};

NECROSIS_PET_LOCAL_NAME = {
	["Imp"] = "Diablotin",
	["Void"] = "Marcheur du Vide",
	["Succubus"] = "Succube",
	["Fel"] = "Chasseur corrompu",
	["Inferno"] = "Infernal",
	["Doomguard"] = "Doomguard"
};

NECROSIS_TRANSLATION = {
	["Cooldown"] = "Temps",
	["Hearth"] = "Pierre de foyer",
	["Rank"] = "Rang",
	["Invisible"] = "D\195\169tection de l'invisibilit\195\169",
	["LesserInvisible"] = "D\195\169tection de l'invisibilit\195\169 inf\195\169rieure",
	["GreaterInvisible"] = "D\195\169tection de l'invisibilit\195\169 sup\195\169rieure",
	["SoulLinkGain"] = "Vous gagnez Lien spirituel.",
	["SacrificeGain"] = "Vous gagnez Sacrifice.",
	["SummoningRitual"] = "Rituel d'invocation"
};

end
